const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function(sequelize, DataTypes) {
  const skills = sequelize.define(
    'skills',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

name: {
        type: DataTypes.TEXT,
      
      

      },

domain: {
        type: DataTypes.ENUM,
      
      

        values: [

"ai_ml",


"cybersecurity",


"cloud",


"hardware",


"web_mobile",


"database",


"general"

        ],

      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  skills.associate = (db) => {


/// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity


























    db.skills.hasMany(db.team_member_skills, {
      as: 'team_member_skills_skill',
      foreignKey: {
          name: 'skillId',
      },
      constraints: false,
    });





















//end loop



    db.skills.belongsTo(db.tenants, {
      as: 'tenant',
      foreignKey: {
        name: 'tenantId',
      },
      constraints: false,
    });

    db.skills.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });




    db.skills.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.skills.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };



  return skills;
};


